package adshttp

import (
	authmiddleware "legalgo-BE-go/internal/api/http/middleware/auth"
	adsdomain "legalgo-BE-go/internal/domain/ads"
	adssvc "legalgo-BE-go/internal/services/ads"
	"legalgo-BE-go/internal/utilities/response"
	"legalgo-BE-go/internal/utilities/utils"
	"net/http"

	"github.com/go-chi/chi/v5"
	"github.com/go-playground/validator/v10"
)

func Create(
	router chi.Router,
	adsSvc adssvc.Ads,
	validate *validator.Validate,
) {
	router.
		With(authmiddleware.Authorize()).
		Post("/ads/create", func(w http.ResponseWriter, r *http.Request) {
			ctx := r.Context()
			var spec adsdomain.AdsReq

			if err := utils.UnmarshalBody(r, &spec); err != nil {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					"failed to unmarshal body",
				)
				return
			}

			if err := validate.Struct(spec); err != nil {
				response.ResponseWithErrorCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.(validator.ValidationErrors).Error(),
				)
				return
			}

			if err := adsSvc.Create(spec); err != nil {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.Error(),
				)
				return
			}

			response.RespondJsonSuccess(ctx, w, struct {
				Message string
			}{
				Message: "ads created successfully",
			})
		})
}
